/* File:    $Id: ArchiveArcRepositoryAdminTesterSuite.java 1417 2010-06-01 15:22:38Z jolf $
 * Version: $Revision: 1417 $
 * Date:    $Date: 2010-06-01 17:22:38 +0200 (Tue, 01 Jun 2010) $
 * Author:  $Author: jolf $
 *
 * The Netarchive Suite - Software to harvest and preserve websites
 * Copyright 2004-2010 Det Kongelige Bibliotek and Statsbiblioteket, Denmark
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package dk.netarkivet.archive.arcrepositoryadmin;

import junit.framework.Test;
import junit.framework.TestSuite;
import junit.textui.TestRunner;

/**
 *  Testsuite for the classes in the dk.netarkivet.archive.arcrepositoryadmin
 *  package.
 */
public class ArchiveArcRepositoryAdminTesterSuite
{
    public static Test suite()
    {
        TestSuite suite;
        suite = new TestSuite(ArchiveArcRepositoryAdminTesterSuite.class.getName());

        addToSuite(suite);

        return suite;
    }

    public static void addToSuite(TestSuite suite) {
        suite.addTestSuite(AdminDataTester.class);
        suite.addTestSuite(DatabaseAdminTester.class);
        suite.addTestSuite(DBTester.class);
        suite.addTestSuite(ReadOnlyAdminDataTester.class);
        suite.addTestSuite(ReplicaCacheDatabaseTester.class);
    }

    public static void main(String args[])
    {
        String args2[] = {"-noloading", ArchiveArcRepositoryAdminTesterSuite.class.getName()};
        TestRunner.main(args2);
    }
}
